// This is the pref #0 for setting application stack size and minimal heap space,
// posted on palm-dev-forum on 02/20/99 by Adam Dingle:
// "To get CodeWarrior to compile the .r file and include it as a resource in your
// program, you need to set up a file mapping. In the "File Mapping" panel of the
// CodeWarrior Settings dialog, add a mapping with file type TEXT, extension ".r"
// and compiler "Rez". Be sure that all four flags ("Resource File","Launchable", 
// "Precompiled" and "Ignored by Make") are clear for this file mapping. Now build
// the application; if you load it into a Palm III and use Insider to look at its
// resources, you'll see that the application has a "pref" resource containing
// the values we specified in the ".r" file...."
//
// An example use of PalmRez can be found in page 180 of the book "Palm Programming -
// The Developer's Guide".                             030499jhc

type 'pref' {
 integer priority;
 longint stackSize;
 longint minHeapSpace;
 };

// Define the pref #0 resource.
resource 'pref' (0) {

// Application priority.  PalmOS uses 30 if there is no pref resource (see SysAppLaunch()).
 30,

// Stack size.  Set as you like.
// 0x1800,    // 10K. 0x1800 for 6K
// 0x2500,    // 9K
 0x8000,    // 32K  d4776 JSY (1/15/2002)

// Minimum heap space.  PalmOS uses 0x1000 as default (see SysAppLaunch()).
// 0x1800    // 8K
 0x8000,    // 32K  d4776 JSY (1/15/2002)
 };
