// SampleBaseControl.cpp
                                                     
#include "SampleBaseControl.h"
                                                     
CSampleBaseControl::~CSampleBaseControl()
	{
                                                    
	if(iControls)
		{
		iControls->ResetAndDestroy();   
		delete iControls;
		iFocusedControl = NULL;
		}
                                                    
	}
                                                    
void CSampleBaseControl::ConstructL()
	{
                                                     
	iControls = new CArrayPtrFlat<CCoeControl>(1);   
    iFocusedControl = NULL;
                                                     
	}
                                                    
void CSampleBaseControl::HandleControlEventL(CCoeControl* aControl, TCoeEvent aEventType)
	{
                                                    
	switch (aEventType)
		{
		case EEventRequestFocus:  
		if(iFocusedControl != aControl)
			{
			 if(iFocusedControl)
				{
				iFocusedControl->SetFocus(EFalse, EDrawNow);
				}
			iFocusedControl = aControl;
			iFocusedControl->SetFocus(ETrue, EDrawNow);
			}
		break;

		case EEventPrepareFocusTransition:
		if(iFocusedControl)
			{
			iFocusedControl->PrepareForFocusLossL();
            }
			break;

		case EEventStateChanged:
		ReportEventL(MCoeControlObserver::EEventStateChanged);
		break;

		default:
		break;
		}
                                                
	}
                                                     
TKeyResponse CSampleBaseControl::OfferKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType)
	{
                                                     
		{
		return iFocusedControl->OfferKeyEventL(aKeyEvent, aType);
		}
                                                    
	return EKeyWasNotConsumed;
                                                     
	}
                                                     
void CSampleBaseControl::FocusChanged(TDrawNow aDrawNow)
	{
                                                     
	if(iFocusedControl)
		{
		iFocusedControl->SetFocus(IsFocused(), aDrawNow);
		}
                                                     
	}
                                                   
void CSampleBaseControl::PrepareForFocusLossL()
	{
                                                     
	if(iFocusedControl)
		{
		iFocusedControl->PrepareForFocusLossL();
		}
   	}
                                                    
TInt CSampleBaseControl::CountComponentControls() const
	{
                                                     
	return iControls->Count(); 
	}
                                                    
CCoeControl* CSampleBaseControl::ComponentControl(TInt aIndex) const
	{
                                                     
	if(aIndex < iControls->Count())
		return iControls->At(aIndex);
	else
		return NULL;
                                                     
	}
                                                    
