// Sample.cpp

#include "sqlcli1.h"
#include "sqlcli.h"
#include <stdio.h>
#include <string.h>

#define MAX_STATEMENT_LENGTH 128

int main(int argc, char * argv[])
{
	SQLHANDLE henv, hdbc, hstmt ;
	SQLRETURN rc ;
	wchar_t buf[MAX_STATEMENT_LENGTH] = {0};
	SQLINTEGER  empno = 0, selectItem = 0;

	argc=0;
	argv=NULL;
	
	printf("#Sample Code Begin....#\n");

	rc = SQLAllocEnv(&henv);
    if ( rc != SQL_SUCCESS ) { 
		printf("allocating env handle failed..\n");
		goto exit;
	}

	rc = SQLAllocConnect(henv,&hdbc);
    if ( rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) { 
		printf("allocating myconnection handle failed..\n");
		goto exit;
	}

	rc = SQLConnect((SQLHDBC) hdbc, (SQLTCHAR*) "sample", SQL_NTS, (SQLTCHAR*) "user", SQL_NTS, (SQLTCHAR*) "password", SQL_NTS);
	if (rc!=SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) { 
		printf("SQLConnect failed..\n");
		goto exit;
	}

    rc = SQLAllocHandle( SQL_HANDLE_STMT, hdbc, &hstmt ) ;
	if (rc!=SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) { 
		printf("allocating stmt handle failed..\n");
		goto exit;
	}

	wcscpy(buf, L"CREATE TABLE employee(EMPNO CHAR(10))");
    rc = SQLExecDirect( hstmt, (SQLTCHAR*) buf, SQL_NTS ) ;
	if (rc!=SQL_SUCCESS) { // error
		printf("Creating table employee failed..\n");
		goto exit;
	}
	printf("Create table: employee....\n");
	
	wcscpy(buf, L"INSERT INTO employee VALUES('0000000001')");
	rc = SQLExecDirect( hstmt, (SQLTCHAR*) buf, SQL_NTS ) ;
	if (rc!=SQL_SUCCESS  && rc != SQL_SUCCESS_WITH_INFO) { 
		printf("Inserting into employee failed...\n");
		goto exit;
	}
	printf("Insert one record into employee\n");

	wcscpy(buf, L"SELECT * FROM employee");
	rc = SQLExecDirect( hstmt, (SQLTCHAR*) buf, SQL_NTS ) ;
	if (rc!=SQL_SUCCESS  && rc != SQL_SUCCESS_WITH_INFO) { 
		printf("Selecting from employee failed");
		goto exit;
	}

	printf("*** Query results ***:\n");
	rc = SQLBindCol(hstmt, 1, SQL_C_LONG, (SQLPOINTER) &empno, sizeof(empno), &selectItem);
	
	while ((rc = SQLFetch(hstmt)) == SQL_SUCCESS)
	{
		printf("EMPNO=%d\n", (int) empno);
	}

	wcscpy(buf, L"DROP TABLE employee");
	rc = SQLExecDirect(hstmt, (SQLTCHAR*) buf, SQL_NTS);
	if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO)
	{
		printf("Drop table employee failed...\n");
		goto exit;
	}
	printf("*** Drop table: employee\n");


exit:
	if (hstmt) SQLFreeStmt(hstmt, SQL_DROP);
	if (hdbc) SQLDisconnect(hdbc);
	if (hdbc) SQLFreeConnect(hdbc);
	if (henv) SQLFreeEnv(henv);

	printf("#Sample Code End....#\n");
	return rc;
}